#!/bin/sh
#
echo Create the mSQL/Apache1.00 demo/testbed
# Version 1.00 31/11/1996 Dirk.vanGulik@jrc.it
#
# webserver port
PORT=1234

if which httpd; then
	HTTPD=httpd
	else
	echo Guessing location of the httpd
	HTTPD=/httpd/httpd
	fi

if which netscape; then
	CLIENT=netscape
	echo Using netscape as web browser
	else
	echo Guessing location of the WWW Browser
	CLIENT=/usr/local/bin/netscape
	fi

CPP=/usr/ccs/lib/cpp
#
# Step one, create a conf directory, if it
# is not there
if [ -d conf ] ; then
	echo  there was already a conf directory
 	else
	mkdir conf
	fi
#
# Step two, create the 3 config files
#
for FILE in access httpd srm; do
	$CPP -P -I. -DROOT=`pwd` -DPORT=$PORT conf-dist/$FILE.conf-dist conf/$FILE.conf
	done
#
# copy the mime.types file
#
cp conf-dist/mime.types conf/mime.types

# step three, create the databases	
create-databases.pl

# step four, start up a web server
echo "Kicking off the web server"
$HTTPD -d `pwd`

echo "OK all done now, have fun !"
$CLIENT http://localhost:$PORT/index.html
